#include <map>
#include <string>
#include <vector>
#include "ctx.h"

#ifndef memory_Context_HEADER
#define memory_Context_HEADER

struct memory_Context {
  bool didLaunch = false;
  bool exit = false;
  std::string input = "";
  std::vector<int> hiddenItems;
  std::vector<int> mismatchedItems;
  std::string recentField = "none";
  std::string outputGoOn = "";
  std::string outputGreeting = "";
  std::string outputHelp = "";
  std::string outputMatchedItems = "";
  std::string outputMismatchedItems = "";
  std::string outputPromptSelection = "";
  std::string outputVictory = "";
  std::map<int, int> playfieldItems;
  int playfieldSize = 0;
  int selectedId = -1;
  std::vector<int> selectedItems;
  bool victory = false;

  template <typename T> T field(const std::string &fieldName);
  template <typename T> void setField(const std::string &fieldName, T value);
};

memory_Context memory_createContext();

#endif // memory_Context_HEADER
